import { BpSdkStore, removeActiveAnswerId, searchChoices, searchChoicesWithNudges } from '@boldpenguin/sdk-redux';
import { IBusinessClassificationSelectorContainerComponent, IChoice, IPartnerEngineConfig } from '@boldpenguin/sdk-types';
import { Unsubscribe } from '../../services/redux-store.service';
export declare class BpSdkBusinessClassificationSelectorContainer implements IBusinessClassificationSelectorContainerComponent {
    storeUnsubscribe?: Unsubscribe;
    searchChoices: typeof searchChoices;
    searchChoicesWithNudges: typeof searchChoicesWithNudges;
    removeActiveAnswerId: typeof removeActiveAnswerId;
    /**
     * Answer id
     */
    answerId: string;
    /**
     * Question id
     */
    questionId: string;
    /**
     * Question code
     */
    code: string;
    /**
     * Placeholder to display
     */
    placeholder: string;
    /**
     * Is required value
     */
    required: boolean;
    /**
     * Error messages
     */
    errors: string[] | undefined;
    /**
     * Error text
     */
    errorText: string | undefined;
    /**
     * Aria label id's that describes input for screen readers
     */
    labelId: string;
    /***
     * Selected choice
     */
    choiceId: string;
    /**
     * Is touched
     */
    touched: boolean;
    /**
     * Is pristine
     */
    pristine: boolean;
    /**
     * Is answer in complete state
     */
    isCompleted: boolean;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    isReadOnly: boolean;
    /**
     * Field type
     */
    fieldType: string;
    /**
     * Label to use
     */
    label: string;
    /**
     *  Labels that describe group
     */
    labelledBy: string;
    /**
     * Choices from answer
     */
    choices: IChoice[];
    /**
     * Choices injected from redux
     */
    remoteChoices: IChoice[];
    /**
     * Show naics code preference injected from redux
     */
    showNaicsCode: boolean;
    /**
     * Show confidence score preference injected from redux
     */
    showConfidence: boolean;
    /**
     * config injected from redux
     */
    config: IPartnerEngineConfig;
    /**
     * Help text
     */
    helpText: string;
    /**
     * Specifically how the question was answered (ie. "ACORD 126")
     */
    answeredBySource: string | undefined;
    choiceMap: {
        [choiceId: string]: IChoice[];
    };
    _selectedChoices: IChoice[];
    _searchChoices: IChoice[];
    _currentSearchValue: string;
    useExternal: boolean;
    showChoices: boolean;
    el: HTMLBpSdkBusinessClassificationSelectorContainerElement;
    resetState(): void;
    handleSubscriptions: () => void;
    connectedCallback(): void;
    componentWillLoad(): void;
    mapStateToProps: (state: BpSdkStore) => {
        remoteChoices: IChoice[];
        config: IPartnerEngineConfig;
    };
    disconnectedCallback(): void;
    onQuestionIdChange(): void;
    doSearchChoices(): void;
    onFilterUpdate({ detail }: CustomEvent<{
        value: string;
    }>): void;
    onRefilterAnswer(): void;
    onValueUpdate(): void;
    onChoicesChange(choices: IChoice[]): void;
    onChoicesUpdate(choices: IChoice[]): void;
    onChoiceMapUpdate(choiceMap: {
        [choiceId: string]: IChoice[];
    }): void;
    updateComposedChoices(searchChoices: IChoice[], choiceMap: {
        [choiceId: string]: IChoice[];
    }): void;
    render(): any[];
    renderExternal(): any;
    renderInternal(): any[];
}
