import { BpSdkStore, addQuestionPool } from '@boldpenguin/sdk-redux';
import { IApplicationFormQuestionSet, IPartnerEngineConfig, IQuestionPoolContainerComponent } from '@boldpenguin/sdk-types';
import { Unsubscribe } from '../../services/redux-store.service';
export declare class BpSdkQuestionPoolContainer implements IQuestionPoolContainerComponent {
    storeUnsubscribe?: Unsubscribe;
    addQuestionPool: typeof addQuestionPool;
    /**
     * Add button text
     */
    addText: string;
    /**
     * Answer pool id
     */
    answerPoolId: string | undefined;
    /**
     * Question pool code
     */
    code: string;
    /**
     * Question pool description
     */
    description: string;
    /**
     * Question pool display text
     */
    displayText: string;
    /**
     * Question pool guid
     */
    guid: string;
    /**
     * Parent question pool id
     */
    parentQuestionPoolId: string | null;
    /**
     * Parent question pool reference id
     */
    parentQuestionPoolReferenceId: string | null;
    /**
     * Question pool owner id
     */
    ownerId: string;
    /**
     * Anchor question id
     */
    parentQuestionId: string;
    /**
     * Remove button text
     */
    removeText: string;
    /**
     * tenant id for question pool
     */
    tenantId: string;
    /**
     * Question Id
     */
    questionId: string;
    /**
     * Question Id
     */
    questionSetId: string;
    config: IPartnerEngineConfig;
    applicationId: string;
    currentQuestionSet: IApplicationFormQuestionSet;
    useExternal: boolean;
    selectParentPoolQuestion: boolean;
    el: HTMLBpSdkQuestionPoolContainerElement;
    onParentQuestionPoolSelected(event: CustomEvent): void;
    resetState(): void;
    handleSubscriptions: () => void;
    connectedCallback(): void;
    componentWillLoad(): void;
    mapStateToProps: (state: BpSdkStore) => {
        applicationId: string;
        config: IPartnerEngineConfig;
        currentQuestionSet: IApplicationFormQuestionSet;
    };
    disconnectedCallback(): void;
    handleAddItem: () => void;
    getParentAnswers(): import("@boldpenguin/sdk-types").IAnswer[];
    render(): any[];
    renderExternal(): any;
    renderAnswer(): any;
    renderInternal(): any;
}
