import { HandleActionBindFunction, HandleAttachmentDownloadFunction, HandleBindFunction, IAnalyticsTrackEventDetail, ICallToAction, ICarrier, IProductDetail, IQuoteAction, IQuoteAttachment, IQuoteInfo, IQuoteRequestComponent, IQuoteStatus, ITranslatedMessage, QuoteRequestRequestTypes } from '@boldpenguin/sdk-types';
import { EventEmitter } from '../../stencil-public-runtime';
export declare class BpSdkQuoteRequest implements IQuoteRequestComponent {
    bpAnalyticsTrack: EventEmitter<IAnalyticsTrackEventDetail>;
    /**
     * Quote actions
     */
    actions: IQuoteAction[];
    /**
     * Quote attachments
     */
    attachments: IQuoteAttachment[];
    /**
     * Is bindable
     */
    bindable: boolean;
    /**
     * User has permission to bind
     */
    permittedToBind: boolean;
    /**
     * Carrier
     */
    carrier: ICarrier;
    /**
     * Product selection
     */
    products: IProductDetail[];
    /**
     * Quote information
     */
    quoteInfo: IQuoteInfo;
    /**
     * Should show logo
     */
    showLogo: boolean;
    /**
     * Should show custom logo
     */
    showCustomLogo: boolean;
    /**
     * Custom logo url
     */
    customLogoBaseUrl: string;
    /**
     * Quote status flags
     */
    quoteStatus: IQuoteStatus;
    /**
     * Quote id
     */
    quoteId: string;
    /**
     * Application form id
     */
    appFormId: string;
    /**
     * Translated messages
     */
    translatedMessages: ITranslatedMessage[];
    /**
     * Function for running a quote action
     */
    handleAction: HandleActionBindFunction;
    /**
     * quote bind function
     */
    handleBind: HandleBindFunction;
    /**
     * Function for downloading an attachment
     */
    handleDownload: HandleAttachmentDownloadFunction;
    /**
     * Is Annual quote
     */
    isAnnual: boolean;
    calls_to_action: ICallToAction[];
    /**
     * Does this quote contain all of the products that were selected in the application form
     */
    satisfiesApplicationFormProductRequest: boolean;
    /**
     * Quote request status
     */
    requestStatus: QuoteRequestRequestTypes;
    /**
     * Supplier name
     */
    supplierName?: string;
    /**
     * Supplier logo url
     */
    supplierLogoUrl?: string;
    /**
     * Supplier full size logo url
     */
    supplierLogoUrlFull?: string;
    /**
     * Supplier code
     */
    supplierCode?: string;
    /**
     * Parent quote request ID will be populated if this is a wholesale quote
     */
    parentQuoteRequestId?: string;
    useExternal: boolean;
    termLength: string;
    price: string;
    totalPremium: string;
    onCarrierChange(carrier: ICarrier, oldCarrier: ICarrier): void;
    onQuoteStatusChange(quoteStatus?: IQuoteStatus): void;
    componentWillLoad(): void;
    render(): any[];
    renderExternal(): any;
    renderInternal(): any;
    renderActionContainer(): any;
    renderAttachmentContainer(): any;
    renderBindContainer(): any;
}
