import { BpSdkStore } from '@boldpenguin/sdk-redux';
import { ITextInputContainerComponent } from '@boldpenguin/sdk-types';
import { Unsubscribe } from '../../services/redux-store.service';
export declare class BpSdkTextInputContainer implements ITextInputContainerComponent {
    storeUnsubscribe?: Unsubscribe;
    /**
     * Answer id
     */
    answerId: string;
    /**
     * Question id
     */
    questionId: string;
    /**
     * Initial text value
     */
    text: string;
    /**
     * Aria label id's that describes input for screen readers
     */
    labelId: string;
    /**
     * Field type
     */
    fieldType: string;
    /**
     * Placeholder to display
     */
    placeholder: string;
    /**
     * Regular expression pattern input should match
     */
    pattern: string | undefined;
    /**
     * Question code
     */
    code: string;
    /**
     * Is question required
     */
    required: boolean;
    /**
     * minimum length of input
     */
    min: number;
    /**
     * maximum length of input
     */
    max: number;
    /**
     * Error messages
     */
    errors: string[];
    /**
     * Error text
     */
    errorText: string;
    /**
     * is touched
     */
    touched: boolean;
    /**
     * is pristine
     */
    pristine: boolean;
    /**
     * Is answer in complete state
     */
    isCompleted: boolean;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    isReadOnly: boolean;
    /**
     * Label
     */
    label: string;
    /**
     *  Labels that describe group
     */
    labelledBy: string;
    /**
     * Is enabled
     */
    isEnabled: boolean;
    /**
     * Reference type
     */
    referenceType: string;
    /**
     * Is autocomplete enabled
     */
    isAutocompleteEnabled: boolean;
    /**
     * Help text
     */
    helpText: string;
    /**
     * Specifically how the question was answered (ie. "ACORD 126")
     */
    answeredBySource: string | undefined;
    autoComplete: string;
    useExternal: boolean;
    el: HTMLBpSdkTextInputContainerElement;
    _vinErrors: string[];
    resetState(): void;
    handleSubscriptions: () => void;
    connectedCallback(): void;
    componentWillLoad(): void;
    mapStateToProps: (state: BpSdkStore) => {
        isAutocompleteEnabled: boolean;
    };
    onValueUpdate(evt: CustomEvent<string>): void;
    onReferenceTypeChange(referenceType: string): void;
    onCodeChange(code: string): void;
    onFieldTypeChange(fieldType: string): void;
    onIsAutocompleteEnabledChange(isAutocompleteEnabled: boolean): void;
    updateAutocomplete({ code, fieldType, referenceType, isAutocompleteEnabled, }: {
        referenceType: string;
        code: string;
        fieldType: string;
        isAutocompleteEnabled: boolean;
    }): void;
    disconnectedCallback(): void;
    render(): any[];
    renderExternal(): any;
    renderInternal(): any[];
}
